*** Analysis of a randomized complete block experiment with r blocks and v treatments,
*** using a model with fixed block effects and random treatment effects ;

** The dataset ;

data Exemp ;
	input Block Treatment Y ;
	cards ;
	1 1 104
	1 2 106
	1 3 109
	1 4 111
	2 1 121
	2 2 128
	2 3 132
	2 4 130
	3 1 88
	3 2 89
	3 3 92
	3 4 95
	;
run ;


** Model fit ;
* Calculation of prediction interval for the difference between Treatments 1 and 2 ;
* Sampling from posterior distribution of random effects ;

proc mixed data = Exemp ; 
	class Block Treatment ;
	model Y = Block / noint ddfm = Sat ; * ddfm = kr ;
	random Treatment / solution ;
	estimate "Treatment 2 - Treatment 1" | Treatment 1 -1 / cl ;
	prior / out = PostBLUP nsample = 50000 ;
run ;

* Bayesian credible interval ;

proc univariate data = PostBlup ;
	var est1 ;
	output out = CoverageInterval  mean = Mean pctlpre=Percentile_ pctlpts= 2.5 97.5 n = n ;
run ;

proc print data = CoverageInterval ;
run ;
